/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-angular-core";
import { Style } from "igniteui-angular-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterPolygonSeries = /*@__PURE__*/ (() => {
    class ScatterPolygonSeries extends ShapeSeriesBase {
        constructor() {
            super();
            this.aaj = null;
            this.aag = new ScalerParams(1, ScatterPolygonSeries.abp, ScatterPolygonSeries.abp, false);
            this.aah = new ScalerParams(1, ScatterPolygonSeries.abp, ScatterPolygonSeries.abp, false);
            this.aa5 = null;
            this.aab = 1;
            this.z7 = 1;
            this.ab = ScatterPolygonSeries.$;
        }
        bj() {
            return new ScatterPolygonSeries();
        }
        get_fq() {
            return true;
        }
        get_fl() {
            return true;
        }
        yd() {
            return this.aal();
        }
        zl(a) {
            let b = a;
            b.cy(this.abr);
            b.cz(this.aak);
            super.zl(a);
            if (this.d5(a)) {
                return;
            }
            let c, d;
            let e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            let f = this.getEffectiveViewport1(a);
            this.aag = new ScalerParams(1, d, c, this.xc.ch);
            this.aag.c = f;
            this.aah = new ScalerParams(1, d, c, this.xe.ch);
            this.aah.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.aaj = ((() => {
                let $ret = new ShapeAxisInfoCache();
                $ret.a = this.xc;
                $ret.b = this.xe;
                $ret.e = this.xc.ch;
                $ret.f = this.xe.ch;
                $ret.d = this.dn;
                $ret.c = this.xu;
                return $ret;
            })());
            if (this.aal()) {
                let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
                b.dg.l(g, 400, d, c, this.id);
                b.dg.j(g, false);
                if (this.yb()) {
                    this.aa2(a);
                }
            }
        }
        aa2(a) {
            a.dk = true;
            this.xj.ay(this, this.yb(), runOn(this, this.w2));
            let b = this.xj.d;
            let c = b != null;
            let d = this.getEffectiveViewport1(a);
            let e = this.dn == null ? 0 : this.dn.count;
            a.dw((f) => {
                if (f._visibility == 0) {
                    let g = f.ak;
                    let h = f.content;
                    if (h == null) {
                        h = new DataContext();
                        f.content = h;
                    }
                    if (c) {
                        this.zg(g, e, a.q);
                    }
                    this.xj.ac(f, h);
                }
            });
        }
        aal() {
            return this.aa5 != null && ((this.aaf != 1 && this.aaf != 0) || this.aa6 != null);
        }
        cs() {
            return new ScatterPolygonSeriesView(this);
        }
        qz(a) {
            super.qz(a);
            this.aai = a;
        }
        get_hasMarkers() {
            return true;
        }
        get_el() {
            return this.aaf != 13 && this.aaf != 1;
        }
        vj() {
            return this.abl;
        }
        vk() {
            return this.abm;
        }
        sx() {
            return this.aa4;
        }
        ma() {
            return this.mb(this, this.aa5);
        }
        io() {
            return this.aan;
        }
        get aac() {
            return this.aab;
        }
        set aac(a) {
            this.aab = a;
        }
        aae() {
            if (this.aad == 0) {
                return 1;
            }
            return this.aad;
        }
        sj(a) {
            super.sj(a);
            this.aad = a;
        }
        get z8() {
            return this.z7;
        }
        set z8(a) {
            this.z7 = a;
        }
        aaa() {
            if (this.z9 == 0) {
                return 2;
            }
            return this.z9;
        }
        si(a) {
            super.si(a);
            this.z9 = a;
        }
        sk(a) {
            super.sk(a);
            this.aan = a;
        }
        sf() {
            super.sf();
            if (this.index < 0) {
                return;
            }
            if (this.aa6 != null) {
                this.aai.dv();
                this.aai.ds();
            }
            else {
                let a = MarkerSeries.w9(this, this.aaf);
                let b = MarkerSeries.xm(a);
                if (b == null) {
                    this.aa4 = MarkerSeries.x1;
                }
                else {
                    this.aai.dp(b);
                }
            }
            if (this.abn != null && this.aaf != 13) {
                this.r6("ActualMarkerBrush");
                let c = this.abl;
                this.aai.dt();
                this.aai.dq();
                let d = this.abl;
                let e = this.fh("ActualMarkerBrush", this.hv.f > 0 ? this.hv.d() : null, c, d);
                this.r8("ActualMarkerBrush", e);
            }
            else {
                if (this.aaf == 13) {
                    this.abl = this.cv.bt();
                }
                else {
                    if (this.z8 != 2) {
                        if (this.db != null) {
                            let f = this.db.ve(this.index);
                            if (!isNaN_(this.ic) && this.ic != 1) {
                                f = BrushUtil.q(f, this.ic);
                            }
                            this.abl = f;
                        }
                        else {
                            this.abl = null;
                        }
                    }
                }
            }
            if (this.abo != null) {
                this.aai.du();
                this.aai.dr();
            }
            else {
                if (this.aaf == 13) {
                    this.abm = this.cv.bt();
                }
                else {
                    if (this.aad == 2) {
                        this.abm = this.abl;
                    }
                    else {
                        this.abm = this.db == null ? null : this.db.vf(this.index);
                    }
                }
            }
            if (this.z8 == 2 && this.abn == null && this.aaf != 13) {
                if (this.abm != null) {
                    let g = this.abm;
                    if (!isNaN_(this.ic) && this.ic != 1) {
                        g = BrushUtil.q(g, this.ic);
                    }
                    this.abl = g;
                }
                else {
                    this.abl = null;
                }
            }
        }
        qq() {
            super.qq();
            this.aac = this.aae();
            this.z8 = this.aaa();
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.rd(b);
                    this.q1();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.aac = this.aae();
                    this.rd(null);
                    this.q1();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.z8 = this.aaa();
                    this.rd(null);
                    this.q1();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.aa5 = d;
                    if (c == MarkerSeries.x1 || d == MarkerSeries.x1 || (c == null || d != null)) {
                        this.aai.dx();
                        this.rp(false);
                    }
                    this.cv.bl();
                    if (this.toolTip != null && this.fi) {
                        this.ba.a$as(this, this.toolTip);
                    }
                    this.rp(false);
                    this.qj();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.aai.cy(this.abr);
                    this.rp(false);
                    this.qj();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.aai.cz(this.aak);
                    this.rp(false);
                    this.qj();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.rp(false);
                    this.qj();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.aal()) {
                        this.rp(false);
                    }
                    break;
            }
        }
        a2(a, b) {
            let c = this.aai.b4(a);
            let d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return super.a2(a, b);
        }
        aa3(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        eb(a, b, c, d, e) {
            if (!this.hasMarkers) {
                return false;
            }
            let f = this.xc;
            let g = new ScalerParams(1, this.db.v4, this.wq, f.ch);
            g.c = this.getEffectiveViewport1(this.cv);
            let h = this.xe;
            let i = new ScalerParams(1, this.db.v4, this.wq, h.ch);
            i.c = this.getEffectiveViewport1(this.cv);
            a.clear();
            this.aai.dw((j) => {
                if (j._visibility == 0) {
                    let k = new SeriesPointOfInterest();
                    let l = j.n;
                    let m = j.o;
                    if (l < this.wq.left || l > this.wq.right || m < this.wq.top || m > this.wq.bottom) {
                        return;
                    }
                    k.d = f.eo(l, g);
                    k.e = h.eo(m, i);
                    k.b = j.content;
                    k.g = this.ve;
                    k.c = j.ak;
                    if (this.g9) {
                        k.g = this.vl(j.ak);
                    }
                    a.add(k);
                }
            });
            return true;
        }
        z5(a, b, c, d, e) {
            if (c == null || c.length != this.aaj.d.count) {
                c = new Array(this.aaj.d.count);
                for (let f = 0; f < this.aaj.d.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = ((() => {
                let $ret = new ScalerParams(1, d, e, this.xc.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let h = ((() => {
                let $ret = new ScalerParams(1, d, e, this.xe.ch);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = this.wh(a);
            let j = this.aaj.a.eo(i.left, g);
            let k = this.aaj.a.eo(i.right, g);
            let l = this.aaj.b.eo(i.bottom, h);
            let m = this.aaj.b.eo(i.top, h);
            if (this.aaj.e) {
                let n = j;
                j = k;
                k = n;
            }
            if (this.aaj.f) {
                let o = l;
                l = m;
                m = o;
            }
            let p = this.aaj;
            let q = p.a;
            let r = p.b;
            let s;
            let t;
            let u = g.d.left;
            let v = g.d.right;
            let w = h.d.top;
            let x = h.d.bottom;
            for (let y = 0; y < this.aaj.d.count; y++) {
                s = 0;
                t = 0;
                let z = null;
                let aa = a.cc.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    let ab = z.c;
                    let ac = RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        }
        aam(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.dn;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
                c++;
            }
            return b;
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.p2(a, c, b);
            return c.toArray();
        }
        p2(a, b, c) {
            this.zd(a, b, c);
        }
    }
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.abp = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:abl:aa7', [Brush.$], 'ActualMarkerOutline:abm:aa8', [Brush.$], 'ActualMarkerTemplate:aa4:aa9', [DataTemplate.$, null], 'MarkerBrush:abn:aba', [Brush.$], 'MarkerCollisionAvoidance:z6:abb', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:z9:abc', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:aad:abd', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:abo:abe', [Brush.$], 'MarkerStyle:abq:abf', [Style.$], 'MarkerTemplate:aa6:abg', [DataTemplate.$, null], 'MarkerThickness:aan:abh', [1, DeviceUtils.g(2)], 'MarkerType:aaf:abi', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:abr:abj', [Style.$, null], 'ShapeStyleSelector:aak:abk', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
})();
/**
 * @hidden
 */
export let ScatterPolygonSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dk = false;
            this.db = null;
            this.dm = null;
            this.dh = null;
            this.df = null;
            this.dj = false;
            this.di = null;
            this.dn = null;
            this.dc = new Marker();
            this.d4 = null;
            this.dc = new Marker();
            this.dc.content = new DataContext();
            this.dh = a;
            this.di = new HashPool$2(Base.$, Marker.$);
            this.dn = new List$1(Marker.$, 0);
            this.dy(this.di);
            this.df = new NumericMarkerManager(1, (b) => this.di.item(b), (b) => this.dh.aaj.d.item(b), runOn(this, this.d2), runOn(this, this.da), runOn(this, this.dl), () => this.dh.z6);
            this.df.q = runOn(this, this.d5);
        }
        au() {
            super.au();
            if (!this.q) {
                this.dh.abo = Defaults.am;
                this.dh.jp = Defaults.z;
                this.dh.aan = Defaults.y;
                this.dh.aaf = Defaults.f;
                this.dh.z9 = Defaults.b;
            }
        }
        get dg() {
            return this.df;
        }
        d2(a) {
            this.dh.aa3(a, this.di);
        }
        da() {
            this.db = this.dh.z5(this, this.di, this.db, this.by, this.bx);
            return this.db;
        }
        dl() {
            this.dm = this.dh.aam(this.di, this.dm);
            return this.dm;
        }
        c5(a, b) {
            return this.c6(a, b, true);
        }
        cm(a, b, c) {
            super.cm(a, b, c);
            ShapeSeriesViewBase.cl(this, a, b);
        }
        ck(a, b) {
            let c = a;
            if (c == null) {
                return;
            }
            c.an = b;
        }
        dw(a) {
            this.di.f(a);
        }
        dy(a) {
            a.create = runOn(this, this.de);
            a.destroy = runOn(this, this.d0);
            a.activate = runOn(this, this.dz);
            a.disactivate = runOn(this, this.d1);
        }
        de() {
            let a = new Marker();
            if (!this.dj) {
                a.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.e;
                    return $ret;
                })());
            }
            a.ah = this.e.aa4;
            this.dn.add(a);
            return a;
        }
        b4(a) {
            let b = this.dd(a, 0);
            if (b == null) {
                b = this.dd(a, 3);
            }
            return b;
        }
        dd(a, b) {
            let c;
            let d;
            let e;
            let f;
            for (let g = this.dn.count - 1; g >= 0; g--) {
                let h = this.dn._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        }
        d0(a) {
            a.content = null;
            this.dn.remove(a);
        }
        dz(a) {
            a._visibility = 0;
        }
        d1(a) {
            if (a.content != null) {
                (typeCast(DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        }
        d3(a) {
            this.dj = a;
        }
        bj(a, b) {
            super.bj(a, b);
            if (!this.dk) {
                let c = a;
                let d = c.content;
                if (d != null) {
                    if (this.dh.abl != null) {
                        d.actualItemBrush = this.dh.abl;
                    }
                    else {
                        d.actualItemBrush = this.b6.u7;
                    }
                    if (this.dh.abl != null) {
                        d.outline = this.dh.abm;
                    }
                    else {
                        d.outline = this.b6.vb;
                    }
                    d.thickness = this.dh.aan;
                }
            }
        }
        bk(a, b) {
            super.bk(a, b);
            let c = a;
            this.dc._visibility = c._visibility;
            this.dc.ah = c.ah;
            this.dc.width = c.width;
            this.dc.height = c.height;
            this.dc.m = c.m;
            this.dc.l = c.l;
            this.dc.n = c.n;
            this.dc.o = c.o;
            let d = this.bs(b);
            let e = this.dc.content;
            let f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.dh.aan + 3;
            }
        }
        a7(a, b) {
            super.a7(a, b);
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.h();
            c.viewportTop = this.bx.top;
            c.viewportLeft = this.bx.left;
            c.viewportWidth = this.bx.width;
            c.viewportHeight = this.bx.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.h();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.dh.aa4 != null && this.dh.aa4.passStarting != null) {
                this.dh.aa4.passStarting(c);
            }
            for (let j = 0; j < this.dn.count; j++) {
                let k = this.dn._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bi(k, j, b);
                if (b) {
                    k = this.dc;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.q(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.dh.aa4 != null && this.dh.aa4.passCompleted != null) {
                this.dh.aa4.passCompleted(c);
            }
        }
        dv() {
            this.dh.aa4 = null;
        }
        ds() {
            this.dh.aa4 = null;
            this.dh.aa4 = this.dh.aa6;
        }
        dt() {
            this.dh.abl = null;
        }
        dq() {
            this.dh.abl = null;
            if (!isNaN_(this.e.ic) && this.e.ic != 1) {
                let a = BrushUtil.q(this.dh.abn, this.e.ic);
                this.dh.abl = a;
            }
            else {
                this.dh.abl = this.dh.abn;
            }
        }
        du() {
            this.dh.abm = null;
        }
        dr() {
            this.dh.abm = null;
            this.dh.abm = this.dh.abo;
        }
        dp(a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r1;
                    break;
                case "TriangleMarkerTemplate":
                    this.dh.aa4 = this.dh.db.sa;
                    break;
                case "PyramidMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r7;
                    break;
                case "SquareMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r8;
                    break;
                case "DiamondMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r2;
                    break;
                case "PentagonMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r5;
                    break;
                case "HexagonMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r3;
                    break;
                case "TetragramMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r5;
                    break;
                case "PentagramMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r6;
                    break;
                case "HexagramMarkerTemplate":
                    this.dh.aa4 = this.dh.db.r4;
                    break;
            }
        }
        dx() {
            for (let a of fromEnum(this.dn)) {
                a.ah = this.dh.aa4;
            }
            this.as();
        }
        d5(a) {
            if (this.d4 == null) {
                this.d4 = new DataTemplateMeasureInfo();
                this.d4.context = this.k.h();
            }
            this.d4.width = a.width;
            this.d4.height = a.height;
            this.d4.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.d4);
            }
            return new Size(1, this.d4.width, this.d4.height);
        }
        an(a) {
            let b = a;
            super.an(b);
            for (let c of fromEnum(this.di.c)) {
                let d = this.di.item(c);
                if (d._visibility != 1) {
                    let e = typeCast(ScatterPolygonSeries.$, this.e);
                    let f = this.e.bc.getMarkerVisualData(e, d, e.aa4);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.e.ba.a$u(this.e);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dh.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
})();
